﻿ CleanAndSave;dflags;integrity;∆refs
⍝ Utility function to Save a WS while heavily using .Net objects.
⍝ It will remove all the .Net objects, compact and check the integrity of the WS.
⍝ If there is a problem it will suggest a way to try to recuperate the WS using SALT.
⍝ Requirements: v14.1 or better.

⍝ 1. Close AppDomain
 {}2101⌶0


⍝ 2. Erase all the .Net objects (adapted from a post on the forum from Phil Last)
 ∆refs←{                             ⍝ Vector of sub-space references for ⍵.
     ⍺←⍬ ⋄ (⍴,⍺)↓⍺{                  ⍝ default exclusion list.
         ⍵∊⍺:⍺                       ⍝ already been here: quit.
         ⍵.(↑∇∘⍎⍨/⌽(⊂⍺∪⍵),↓⎕NL 9.1)  ⍝ recursively traverse any sub-spaces.
     }⍵                              ⍝ for given starting ref.
 }

 {⍵.⎕EX ⍵.⎕NL-9.2}∆refs #


⍝ 3. Clean-Up and Compact the WS
 {}⎕WA


⍝ 4. Check integrity of WS (Contributed by Dyalog)
 dflags←2 ⎕NQ'.' 'setdflags' 417

 :If 0=2 ⎕NQ'.' 'wscheck'
    ⍝ WS integrity is OK
     integrity←1
 :Else
    ⍝ WS integrity is not OK
     integrity←0
 :EndIf

 2 ⎕NQ'.' 'setdflags'dflags


⍝ 5. Save the WS
 :If integrity
    ⍝ Save the WS to ⎕WSID location without the state indicator.
     0 ⎕SAVE ⎕WSID
     ⎕←'WS Saved: ',⎕WSID

 :Else
    ⍝ There is a problem with the WS integrity.
     ⎕←'WS NOT Saved and may be corrupted.'
     ⎕←'Try Saving the WS as Text using SALT.Snap and Reload-it using SALT.Boot'
     ''
     ']CLEAN'
     '⎕SE.SALT.Snap ''',⎕WSID,'_Snap -loadfn -makedir'' ⍝ Save the WS as text'
     ')CLEAR'
     '⎕SE.SALT.Boot ''',⎕WSID,'_Snap\load_ws.dyalog -xload'' ⍝ Reload the WS saved as text'
     ']CLEAN'
     '⍝ Inspect the WS if complete and re-save it'

 :End